﻿Imports System.Runtime.Serialization
Imports System.Runtime.Serialization.Formatters.Binary

Public Class Form2

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim sTmp As String = SelectFolder(Me, srcPath)
        If Not String.IsNullOrEmpty(sTmp) Then
            Me.TextBox1.Text = sTmp
            Me.TextBox2.Text = sTmp
        End If

    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim sTmp As String = SelectFolder(Me, srcPath)
        If Not String.IsNullOrEmpty(sTmp) Then Me.TextBox2.Text = sTmp

    End Sub

    '設定
    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        If String.IsNullOrEmpty(TextBox1.Text) Then
            MsgBox("入力TSファイルが格納されているフォルダを入力してください。", MsgBoxStyle.Critical + MsgBoxStyle.OkOnly)
            Exit Sub
        End If
        If String.IsNullOrEmpty(TextBox2.Text) Then
            MsgBox("出力TSファイルを格納するフォルダを入力してください。", MsgBoxStyle.Critical + MsgBoxStyle.OkOnly)
            Exit Sub
        End If

        Dim appSettings As New Settings
        '保存先のファイル名
        Dim fileName As String = Application.StartupPath + "\settings.config"
        With appSettings
            .srcPath = Me.TextBox1.Text
            .dstPath = Me.TextBox2.Text
        End With

        srcPath = Me.TextBox1.Text
        dstPath = Me.TextBox2.Text

        Dim bf1 As New BinaryFormatter
        Dim fs1 As New System.IO.FileStream(fileName, System.IO.FileMode.Create)
        bf1.Serialize(fs1, appSettings)
        fs1.Close()
        appSettings = Nothing

        Me.Close()

    End Sub

    'キャンセル
    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        '何もしない
        Me.Close()

    End Sub

    Private Sub Form2_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Me.TextBox1.Text = srcPath
        Me.TextBox2.Text = dstPath

    End Sub
End Class