
#include "StdAfx.h"
#include <windows.h>
#include "TsFileRead.h"

//
// TSt@Cǂݍ݃NX 
// TSFileRead̃o`
TsFileRead::TsFileRead(_TCHAR* fname)
{
	hReadFile = CreateFile( fname, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_FLAG_SEQUENTIAL_SCAN, NULL);
    if (hReadFile == INVALID_HANDLE_VALUE){
		fprintf(stderr,"Ǎ݃t@CI[vG[. error code %d.\n",GetLastError());
		exit(1);
    }
}

TsFileRead::~TsFileRead(void)
{
	CloseHandle(hReadFile);
}

void TsFileRead::Seek(__int64 point)
{
	long	dis = point & 0xffffffff;
	long	highdis = ( point >> 32 ) & 0xffffffff;
	DWORD	pfile;

	pfile = SetFilePointer( hReadFile, dis, &highdis, FILE_BEGIN );
	if( pfile == -1){
		fprintf(stderr,"V[NG[. error code %d.\n", GetLastError());
		exit( 1 );
	}
}

int TsFileRead::Read(byte* buf,int len)
{
	DWORD dwBytes;

	if(!ReadFile( hReadFile, buf, len, &dwBytes, NULL )){
		fprintf(stderr,"[hG[. error code %d.\n", GetLastError());
		exit( 1 );
	}
	return dwBytes;
}
__int64 TsFileRead::Size(void)
{
	LARGE_INTEGER fileSize;
	GetFileSizeEx( hReadFile, &fileSize );

	return(fileSize.QuadPart);

}

//
// TSt@C݃NX
TsFileWrite::TsFileWrite(_TCHAR* fname)
{
	hWriteFile = CreateFile( fname, GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL );
    if (hWriteFile == INVALID_HANDLE_VALUE){
		fprintf(stderr,"݃t@CI[vG[. error code %d.\n", GetLastError());
		exit(1);
    }

}

TsFileWrite::~TsFileWrite(void)
{
	CloseHandle(hWriteFile);
}

bool TsFileWrite::Write(byte* buf,int len)
{
	DWORD dwBytes;
	if(!WriteFile( hWriteFile, buf, len, &dwBytes, NULL )){
		fprintf(stderr,"f[^ݒɃG[܂. error code %d.\n", GetLastError());
		exit( 1 );
	}
	return true;
}
