
#include "stdafx.h"
#include "tsPacket.h"

__int64 getValuePCR(byte* nVideo,__int64 nBuffPoint)
{//Dim PCR As Long = (CLng(nVideo(nBuffPoint + 6)) * &H1000000 + CLng(nVideo(nBuffPoint + 7)) * &H10000 + CLng(nVideo(nBuffPoint + 8)) * &H100 + nVideo(nBuffPoint + 9)) * 2 + (nVideo(nBuffPoint + 10) And &H80) \ &H80
	__int64 PCR = ((((__int64)nVideo[nBuffPoint + 6] << 24 ) + ((__int64)nVideo[nBuffPoint + 7] << 16 ) + ((__int64)nVideo[nBuffPoint + 8] << 8 ) + nVideo[nBuffPoint + 9]) << 1 ) + ((nVideo[nBuffPoint + 10] & 0x80) >> 7);
    PCR *= 300;
    PCR += (((nVideo[nBuffPoint + 10] & 1) << 8 ) + nVideo[nBuffPoint + 11]);
    return PCR;
}

    //Private Function getValuePTS(ByVal adpBytes As Int32) As Long
__int64 getValuePTS(byte* nVideo,__int64 nBuffPoint,int adpBytes)
{//Dim PTS As Long = ((CLng(nVideo(nBuffPoint + adpBytes + 13)) And &HE) \ 2) * &H40000000 + CLng(nVideo(nBuffPoint + adpBytes + 14)) * &H400000 + ((CLng(nVideo(nBuffPoint + adpBytes + 15)) And &HFE) \ 2) * &H8000 + CLng(nVideo(nBuffPoint + adpBytes + 16)) * &H80 + CLng(nVideo(nBuffPoint + adpBytes + 17)) \ 2
	__int64 PTS = ((((__int64)nVideo[nBuffPoint + adpBytes + 13] & 0xe) >> 1 ) << 30 ) + ((__int64)nVideo[nBuffPoint + adpBytes + 14] << 22 ) + ((((__int64)nVideo[nBuffPoint + adpBytes + 15] & 0xfe) >> 1) << 15) + ((__int64)nVideo[nBuffPoint + adpBytes + 16] << 7 ) + ((__int64)nVideo[nBuffPoint + adpBytes + 17] >> 1);
    return PTS;

}

    //Private Function getValueDTS(ByVal adpBytes As Int32) As Long
__int64 getValueDTS(byte* nVideo,__int64 nBuffPoint,int adpBytes)
{//Dim DTS As Long = ((CLng(nVideo(nBuffPoint + adpBytes + 18)) And &HE) \ 2) * &H40000000 + CLng(nVideo(nBuffPoint + adpBytes + 19)) * &H400000 + ((CLng(nVideo(nBuffPoint + adpBytes + 20)) And &HFE) \ 2) * &H8000 + CLng(nVideo(nBuffPoint + adpBytes + 21)) * &H80 + CLng(nVideo(nBuffPoint + adpBytes + 22)) \ 2
	__int64 DTS = ((((__int64)nVideo[nBuffPoint + adpBytes + 18] & 0xe) >> 1 ) << 30 ) + ((__int64)nVideo[nBuffPoint + adpBytes + 19] << 22 ) + ((((__int64)nVideo[nBuffPoint + adpBytes + 20] & 0xfe) >> 1) << 15 ) + ((__int64)nVideo[nBuffPoint + adpBytes + 21] << 7 ) + ((__int64)nVideo[nBuffPoint + adpBytes + 22] >> 1 );
    return DTS;

}

    //Private Sub setPCRtoArray(ByVal nValue As Long, ByVal c As Int32)
void setPCRtoArray(byte* nVideo,__int64 nBuffPoint,__int64 nValue)
{
	nVideo[nBuffPoint + 10] = (nValue & 299) >> 8;
    nVideo[nBuffPoint + 11] = (nValue & 299) & 0xff;
    nValue /= 300;
    nVideo[nBuffPoint + 10] = nVideo[nBuffPoint + 10] | (nValue & 1);
    nValue >>= 1;
    nVideo[nBuffPoint + 9] = nValue & 0xff;
    nValue >>= 8;
    nVideo[nBuffPoint + 8] = nValue & 0xff;
    nValue >>= 8;
    nVideo[nBuffPoint + 7] = nValue & 0xff;
	nValue >>= 8;
    nVideo[nBuffPoint + 6] = nValue & 0xff;
}


    //Private Sub setPTStoArray(ByVal adpBytes As Int32, ByVal nValue As Long, ByVal c As Int32)
void setPTStoArray(byte* nVideo,__int64 nBuffPoint,__int64 nValue,int adpBytes)       
{
	nVideo[nBuffPoint + adpBytes + 13] = (nVideo[nBuffPoint + adpBytes + 13] & 0xf1) + ((nValue >> 30) << 1) & 0xff;
    //nValue = nValue & &H40000000
	nValue &= 0x3fffffff;
    nVideo[nBuffPoint + adpBytes + 14] = (nValue >> 22) & 0xff;
    //nValue = nValue Mod &H400000
    nValue &= 0x3fffff;
    nVideo[nBuffPoint + adpBytes + 15] = (nVideo[nBuffPoint + adpBytes + 15] & 1) + ((nValue >> 15) << 1) & 0xff;
    //nValue = nValue Mod &H8000
    nValue &= 0x7fff;
    nVideo[nBuffPoint + adpBytes + 16] = (nValue >> 7) & 0xff;
    nVideo[nBuffPoint + adpBytes + 17] = (nVideo[nBuffPoint + adpBytes + 17] & 1) + ((nValue & 0x7f) << 1) & 0xff;
}

//    Private Sub setDTStoArray(ByVal adpBytes As Int32, ByVal nValue As Long, ByVal c As Int32)
void setDTStoArray(byte* nVideo,__int64 nBuffPoint,__int64 nValue,int adpBytes)
{
    nVideo[nBuffPoint + adpBytes + 18] = (nVideo[nBuffPoint + adpBytes + 18] & 0xf1) + ((nValue >> 30 ) << 1) & 0xff;
    //nValue = nValue Mod &H40000000
    nValue &= 0x3fffffff;
    nVideo[nBuffPoint + adpBytes + 19] = (nValue >> 22) & 0xff ;
    //nValue = nValue Mod &H400000
	nValue &= 0x3fffff;
    nVideo[nBuffPoint + adpBytes + 20] = (nVideo[nBuffPoint + adpBytes + 20] & 1) + ((nValue >> 15 ) << 1) & 0xff;
    //nValue = nValue Mod &H8000
	nValue &= 0x7fff;
    nVideo[nBuffPoint + adpBytes + 21] = (nValue >> 7) & 0xff;
    nVideo[nBuffPoint + adpBytes + 22] = (nVideo[nBuffPoint + adpBytes + 22] & 1) + ((nValue & 0x7f) << 1) & 0xff;
}
//    Private Sub makePATArray(ByVal nCounter As Int32)
void makePATArray( byte* InsertPATArray, int nCounter)
{
        //Dim bArray() As Byte = New Byte() {&H47, &H60, 0, &H10, 0, _
        //                                   0, &HB0, &HD, _
        //                                   &H40, &HD1, &HD5, 0, 0, _
        //                                   0, 1, &HE0, &H10, _
        //                                   &HA2, &H33, &H37, &H20}
        //3oCgڏJE^
        //7oCg0x0D=13 ZNV ̃oCgCRC̍Ō܂ł̃oCg

        //32bitCRC
        //CRC32(ByVal buff As Byte(), ByVal st As Int32, ByVal length As Int32) As Long
        //5oCgڂCRC̎O܂

        //JE^
        InsertPATArray[3] = nCounter;

}

//    Private Sub makePMTArray(ByVal nCounter As Int32)
void makePMTArray( byte* InsertPMTArray,int nCounter)
{
        //Dim bArray() As Byte = New Byte() {&H47, &H60, &H10, &H10, 0, _
        //                                   2, &HB0, &H2B, _
        //                                   0, 1, &HDF, 0, 0, &HE0, &H1F, &HF0, &HE, _
        //                                   9, 5, 0, 5, &HE0, &H60, 0, &HC1, 1, &H84, &HDE, 2, &HEF, &HFF, _
        //                                   2, &HE0, &H11, &HF0, 3, &H52, 1, 0, _
        //                                   &HF, &HE0, &H14, &HF0, 3, &H52, 1, &H10, _
        //                                   &HE0, &HC0, 4, &H4E}
        //3oCgڏJE^
        //7oCg0x2B=43 ZNV ̃oCgCRC̍Ō܂ł̃oCg
        //14oCg0x1F PCR_PID

        //JE^
        InsertPMTArray[3] = nCounter;

        //32bitCRC
        //CRC32(ByVal buff As Byte(), ByVal st As Int32, ByVal length As Int32) As Long
        //5oCgڂCRC̎O܂

        //Dim nBytes As Int32 = ((InsertPMTArray(6) And &HF) << 8) + InsertPMTArray(7) + 3 - 4
        //Dim nCRC As Long = CRC32(InsertPMTArray, 5, nBytes)
        //InsertPMTArray(47) = (nCRC >> 24) And &HFF
        //InsertPMTArray(48) = (nCRC >> 16) And &HFF
        //InsertPMTArray(49) = (nCRC >> 8) And &HFF
        //InsertPMTArray(50) = nCRC And &HFF
        //Dim nPoint As Int32 = ((InsertPMTArray(6) And &HF) << 8) + InsertPMTArray(7) + 7
        //InsertPMTArray(nPoint) = nCRC And &HFF
        //nCRC >>= 8
        //InsertPMTArray(nPoint - 1) = nCRC And &HFF
        //nCRC >>= 8
        //InsertPMTArray(nPoint - 2) = nCRC And &HFF
        //nCRC >>= 8
        //InsertPMTArray(nPoint - 3) = nCRC And &HFF

}